/*  --------------------------------------------------- !
! The current code is to:                               !
! (1) demonstrate the effect of vec and no-vec.         !
! (2) mesure the perfomance in terms of walltime.       !
! (3) impact of the data size.                          !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! April 16, 2017                                        !
!----------------------------------------------------- */

# include <omp.h>
# include <stdio.h>
# include <stdlib.h>
# include <math.h>

int main() {

int i,k,nosize;
//const int nsize = 5000;
//const int nsize = 20;
const int nsize = 1000;
const int kitemax = 10000000;
double time_start,time_end;
double *vector_a, *vector_b, *vector_c, *vector_d, *vector_e;
int id,nothread;

  nosize = nsize;


// allocate the vectors.
  vector_a = (double *) malloc( nosize * sizeof(double *) );
  if(vector_a == NULL) printf("Failure to allocate array matrix!\n");
  vector_b = (double *) malloc( nosize * sizeof(double *) );
  if(vector_b == NULL) printf("Failure to allocate array matrix!\n");
  vector_c = (double *) malloc( nosize * sizeof(double *) );
  if(vector_c == NULL) printf("Failure to allocate array matrix!\n");
  vector_d = (double *) malloc( nosize * sizeof(double *) );
  if(vector_d == NULL) printf("Failure to allocate array matrix!\n");
  vector_e = (double *) malloc( nosize * sizeof(double *) );
  if(vector_e == NULL) printf("Failure to allocate array matrix!\n");

// initialize the vectors.
  for (i=0; i<nosize; i++) 
      { vector_a[i] = sin((double)(i));
        vector_b[i] = sin((double)(i+i));
        vector_c[i] = cos((double)(i*i));
        vector_d[i] = cos((double)(i+i+i));
        vector_e[i] = sin((double)(i+i+i+i));
      }


#pragma omp parallel
{
   id = omp_get_thread_num();
   nothread = omp_get_num_threads();
   printf("This is ID %d out of %d\n",id,nothread);
}
 


// start a timer.
   time_start = omp_get_wtime();

//#pragma vector
//#pragma simd

// sum over all vector elements.
   for (k=0; k<kitemax; k++) 
#pragma vector
   for (i=0; i<nosize; i++) 
       { vector_a[i] =  vector_a[i] + vector_b[i] + vector_c[i] + vector_d[i] + vector_e[i] ;
       } 


   time_end = omp_get_wtime();
   printf("Elapsed time (sec) is %.5f\n", time_end-time_start);

   free(vector_a);
   free(vector_b);
   free(vector_c);
   free(vector_d);
   free(vector_e);

}

